Unit QSR1R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTQS11_p;

procedure QSR1R(var RINT :Real; A :Real; B :Real; F :Func_F1;
                var K :Integer; var IERR :Integer);

implementation

procedure QSR1R(var RINT :Real; A :Real; B :Real; F :Func_F1;
                var K :Integer; var IERR :Integer);
var
N,I,J,M :Integer;
D,S,H :Real;
T :Array [0..20] of Real;
label
_1,_2,_3,_4,_5;
begin
IERR := 0;
if ( K  <= 20 ) 
 then goto _1;
IERR := 65;
UTQS11(IERR,9);
goto _5;
_1:
K := Abs(K);
if ( K  = 0 ) 
 then goto _5;
D := B-A;
T[0] := (F(A)+F(B))/2.0;
N := 1;
for I:=1 to K do
 begin
  S := 0.0;
  N := 2*N;
  H := D/N;
  J := 1;
  while ( J<=N ) do
   begin
_2:
    S := S+F(A+J*H);
    inc(J,2);
   end;
  T[I+0] := (2.0*S/N+T[I-1])/2.0;
  M := 1;
  J := I;
_3:
  M := 4*M;
  T[J-1] := T[J+0]+(T[J+0]-T[J-1])/(M-1);
  J := J-1;
  if ( J-1 ) < 0
   then goto _4
   else if ( J-1 ) > 0
         then goto _3
         else goto _3;
_4:
 end;
RINT := T[0]*D;
_5:
end;

end.
